/*---------------------------------------------------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/*---------------------------------------------------------------------*/

#include "AI8051U_NVIC.h"

#define	TRUE	1
#define	FALSE	0

//===================================================


//===================================================

#define	Priority_0			0	//жȼΪ 0 ͼ
#define	Priority_1			1	//жȼΪ 1 ϵͼ
#define	Priority_2			2	//жȼΪ 2 ϸ߼
#define	Priority_3			3	//жȼΪ 3 ߼

#define ENABLE		1
#define DISABLE		0

#define SUCCESS		0
#define FAIL		-1
//========================================================================
// : NVIC_I2C_Init
// : I2CǶжϿʼ.
// : Mode:     ģʽ, I2C_Mode_Master/I2C_Mode_Slave.
// : State:    жʹ״̬, I2C_Mode_Master: ENABLE/DISABLE.
//                              I2C_Mode_Slave: I2C_ESTAI/I2C_ERXI/I2C_ETXI/I2C_ESTOI/DISABLE.
// : Priority: жȼ, Priority_0,Priority_1,Priority_2,Priority_3.
// : ִн SUCCESS/FAIL.
// 汾: V1.0, 2020-09-29
//========================================================================
u8 NVIC_I2C_Init(u8 Mode, u8 State, u8 Priority)
{
	if(Mode > 1) return FAIL;
	if(Mode == 1)	//I2C_Mode_Master
	{
		I2C_Master_Inturrupt(State);
	}
	else if(Mode == 0)	//I2C_Mode_Slave
	{
		I2CSLCR = (I2CSLCR & ~0x78) | State;
	}
	if(Priority <= Priority_3) CMP_Priority(Priority); else  return FAIL;
	return SUCCESS;
}

//========================================================================
// : NVIC_DMA_I2CT_Init
// : DMA I2C TxǶжϿʼ.
// : State:    жʹ״̬, ENABLE/DISABLE.
// : Priority: жȼ, Priority_0,Priority_1,Priority_2,Priority_3.
// : Bus_Priority: ߷ȼ, Priority_0,Priority_1,Priority_2,Priority_3.
// : ִн SUCCESS/FAIL.
// 汾: V1.0, 2022-03-25
//========================================================================
u8 NVIC_DMA_I2CT_Init(u8 State, u8 Priority, u8 Bus_Priority)
{
	DMA_I2CT_CFG &= ~0x0f;
	if(Priority <= Priority_3) DMA_I2CT_CFG |= Priority << 2;
	if(Bus_Priority <= Priority_3) DMA_I2CT_CFG |= Bus_Priority;	//߷ȼ
	if(State == ENABLE)
		DMA_I2CT_CFG |= 0x80;	//bit7 1:Enable Interrupt
	else
		DMA_I2CT_CFG &= ~0x80;	//bit7 0:Disable Interrupt
	return SUCCESS;
}

//========================================================================
// : NVIC_DMA_I2CR_Init
// : DMA I2C RxǶжϿʼ.
// : State:    жʹ״̬, ENABLE/DISABLE.
// : Priority: жȼ, Priority_0,Priority_1,Priority_2,Priority_3.
// : Bus_Priority: ߷ȼ, Priority_0,Priority_1,Priority_2,Priority_3.
// : ִн SUCCESS/FAIL.
// 汾: V1.0, 2022-03-25
//========================================================================
u8 NVIC_DMA_I2CR_Init(u8 State, u8 Priority, u8 Bus_Priority)
{
	DMA_I2CR_CFG &= ~0x0f;
	if(Priority <= Priority_3) DMA_I2CR_CFG |= Priority << 2;
	if(Bus_Priority <= Priority_3) DMA_I2CR_CFG |= Bus_Priority;	//߷ȼ
	if(State == ENABLE)
		DMA_I2CR_CFG |= 0x80;		//bit7 1:Enable Interrupt
	else
		DMA_I2CR_CFG &= ~0x80;	//bit7 0:Disable Interrupt
	return SUCCESS;
}
